<template>
  <div
    :class="`relative flex flex-col items-center mx-auto cursor-pointer provider-logos ${labelProductListFeature}`"
    :style="`background-image: url(${gameForDisplay.BackgroundLogo})`"
  >
    <div
      v-if="product.IsMaintain"
      class="absolute w-[56px] h-[46px] top-[12px] right-[12px] z-[2]"
    >
      <img
        :src="getAssetImage('assets/theme/common/icon/icon_maintainance.png')"
        alt=""
      />
    </div>
    <div class="absolute top-2 left-2 flex flex-col items-center logo-tags gap-1">
      <img
        v-if="gameForDisplay.IsNewGameProvider"
        :src="
          getAssetImage(
            'assets/theme/common/icon/new_icon.svg'
          )
        "
      />
      <img
        v-if="gameForDisplay.IsHotGameProvider"
        :src="
          getAssetImage(
            'assets/theme/common/icon/hot_icon.svg'
          )
        "
      />
    </div>
    <div
      :class="`relative flex items-center justify-center w-full h-full ${
        gameForDisplay.IsNeedLightBackground ? 'light-bg' : ''
      }`"
    >
      <div
        class="flex items-center justify-center w-full h-full float-bg"
        :style="`${
          gameForDisplay.IsNeedFloatBackground
            ? `background-image: url(${gameForDisplay.FloatBackgroundPath})`
            : ''
        }`"
      >
        <img class="main-logo" :src="gameForDisplay.MainLogoPath" />
      </div>
    </div>
    <div
      :class="`absolute bottom-0 label-bg flex flex-col 'justify-center' items-center`"
    >
      <img class="label-logo" :src="gameForDisplay.LabelLogoPath" />
    </div>
  </div>
</template>
<script lang="ts">
import { computed, defineComponent, PropType } from "vue";
import GameForDisplay from "@/models/theme/game_hover_drop_down/GameForDisplay";
import { IGame } from "@/models/IGetPlayableGamesResponse";
import commonHelper from "@/utils/commonHelper";
import { IThemePropertiesFromApi } from "~~/models/companyThemePropertiesRespone";
import { store } from "~~/store";

export default defineComponent({
  name: "ProviderLogo",
  props: {
    product: {
      type: Object as PropType<IGame>,
      required: true,
    },
  },
  setup(props) {
    const gameForDisplay = computed(() => new GameForDisplay(props.product));
    const { getAssetImage } = commonHelper;
    const background = `url(${getAssetImage(
      "assets/theme/common/provider_icon/bg_label/bg_light.png"
    )})`;
    const themeProperties = computed(
      () => store.state.companyThemePropertiesFromApi.ThemeProperties
    );
    const labelProductListFeature = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "product_list_feature"
        )
    ).value.Text;
    return {
      gameForDisplay,
      getAssetImage,
      background,
      labelProductListFeature,
    };
  },
});
</script>
<style lang="scss">
:root {
  --transition-time: 0.4s;
}
.provider-logos {
  width: 13.5vw;
  height: 13.5vw;
  width: 200px;
  height: 200px;
  background-repeat: no-repeat;
  background-size: contain;
  margin-left: 1vw;
  margin-right: 1vw;

  .main-logo {
    transition: var(--transition-time) ease-in-out;
    width: 144px;
    height: 144px;
  }
  .label-logo {
    transition: var(--transition-time) ease-in-out;
    width: 160px;
    height: 65.72px;
  }
  .pt-for-label-with-sub-label {
    padding-top: 9px;
  }
  .label-bg {
    transition: var(--transition-time) ease-in-out;
    width: 160px;
    height: 65.72px;
    left: 0;
    right: 0;
    margin-left: auto;
    margin-right: auto;
  }
  .provider-logos .label-bg {
    width: 12vw;
    height: 3.5vw;
  }
  .logo-label {
    transition: var(--transition-time) ease-in-out;
    width: 3.9vw;
    height: 1.3vw;
  }
  .small-label {
    transition: var(--transition-time) ease-in-out;
    width: 21.6vw;
    height: 0.93vw;
  }
  .logo-label-with-sub-label {
    transition: var(--transition-time) ease-in-out;
    width: 3.2vw;
    height: 1.09vw;
  }
  .light-bg {
    transition: var(--transition-time) ease-in-out;
    background-image: v-bind("background");
    background-size: 0px 0px;
    background-repeat: no-repeat;
    background-position: center;
  }
  .float-bg {
    transition: var(--transition-time) ease-in-out;
    background-size: 140px 140px;
    background-repeat: no-repeat;
    background-position-x: 29px;
    background-position-y: 29px;
  }
  .logo-tags {
    z-index: 1;
    img {
      transition: var(--transition-time) ease-in-out;
      width: 57.15px;
      height: 17.15px;
    }
  }
}

.provider-logos:hover {
  .pt-for-label-with-sub-label {
    padding-top: 8.42px;
  }
  .label-bg,
  .label-logo {
    width: 180px;
    height: 73.94px;
    left: 2px;
    right: 0px;
  }
  .logo-label {
    width: 3.9vw;
    height: 1.51vw;
  }
  .logo-label-with-sub-label {
    width: 3.9vw;
    height: 1.32vw;
  }
  .main-logo {
    width: 178px;
    height: 178px;
    margin-bottom: 25px;
  }
  .light-bg {
    background-size: 90% 90%;
  }
  .small-label {
    width: 57.75px;
    height: 20.25px;
  }
  .logo-tags {
    img {
      width: 68.57px;
      height: 20.57px;
    }
  }
  .float-bg {
    background-size: 190px 190px;
    background-position-x: 8px;
    background-position-y: 5px;
  }
}
.product_list_feature_template_3 {
  .label-bg {
    width: 200px;
    height: 200px;
    bottom: -109px;
  }
  .label-logo {
    width: 100%;
    height: auto;
  }
}
.product_list_feature_template_3:hover {
  .label-bg {
    bottom: -108px;
    width: 200px;
    height: 200px;
    left: 0;
  }
  .label-logo {
    width: 100%;
    height: auto;
  }
}
</style>
